<?php

/**
 * Copyright (c) 2007, Gea-Suan Lin. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: cs.inc.php 7 2007-03-24 13:41:12Z darkkiller $ */

define('CS_CIPHERALGO', MCRYPT_BLOWFISH);
define('CS_CIPHERMODE', MCRYPT_MODE_CBC);
define('CS_HASHALGO', MHASH_SHA1);

function cs_decode($str)
{
    $str = cs_sign_check($str);
    if ($str == FALSE)
	return FALSE;

    return cs_decrypt($str);
}

function cs_decrypt($str)
{
    $td = mcrypt_module_open(CS_CIPHERALGO, '', CS_CIPHERMODE, '');

    $iv_size = mcrypt_get_iv_size(CS_CIPHERALGO, CS_CIPHERMODE);
    $iv = substr(mhash(CS_HASHALGO, CS_SECRET), 0, $iv_size);

    $p = mcrypt_decrypt(CS_CIPHERALGO, CS_SECRET, $str, CS_CIPHERMODE, $iv);
    $a = explode(':', $p, 2);
    $p = substr($a[1], 0, $a[0]);

    return $p;
}

function cs_encode($str)
{
    $str = cs_encrypt($str);
    $str = cs_sign($str);

    return $str;
}

function cs_encrypt($str)
{
    /**
     * At beginning add '123:' for 123 bytes string, to solve padding
     * problem.
     */
    $len = strlen($str);
    $str = $len . ':' . $str;

    $td = mcrypt_module_open(CS_CIPHERALGO, '', CS_CIPHERMODE, '');

    $iv_size = mcrypt_get_iv_size(CS_CIPHERALGO, CS_CIPHERMODE);
    $iv = substr(mhash(CS_HASHALGO, CS_SECRET), 0, $iv_size);

    mcrypt_generic_init($td, CS_SECRET, $iv);

    return mcrypt_generic($td, $str);
}

function cs_sign($str)
{
    $dig = mhash(CS_HASHALGO, $str, CS_SECRET);
    $str = $dig . $str;

    return $str;
}

function cs_sign_check($str)
{
    $len = mhash_get_block_size(CS_HASHALGO);

    if (strlen($str) < $len)
	return FALSE;

    $dig = substr($str, 0, $len);
    $data = substr($str, $len);

    if (mhash(CS_HASHALGO, $data, CS_SECRET) != $dig)
	return FALSE;

    return $data;
}

?>
